



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Adding DOM elements to document</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Adding DOM elements to document</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 12:13:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1、JavaScript 添加DOM Element 执行效率比较：</h1>
<h1>抄自：http://wildbit.com/blog/2006/11/21/javascript-optimization-adding-dom-elements-to-document</h1>
<h1>JavaScript optimization: Adding DOM elements to document</h1>
<div>
<p>Scenario: you&rsquo;re developing rich Web application and you need to load dynamic elements using AJAX and then add them to current document. For some reason you don&rsquo;t want (or can&rsquo;t) use fully generated HTML, and decided to fetch items in JavaScript array.</p>
<p>I know two classic ways to do so: create elements using&nbsp;<tt>document.createElement()</tt>method and concatenate HTML strings and assign result to&nbsp;<tt>parentElement.innerHTML</tt>property. Of course, you can combine both ways. Let&rsquo;s examine these ways in detail.</p>
<p>Classic way (and in ideal world the best way) is to use DOM for element manipulations:</p>
<pre class="prettyprint linenums"><code>for (var i = 1; i &lt; = 1000; i++) {<br />
var li = document.createElement('li');<br />
  li.appendChild(document.createTextNode('Element ' + i));<br />
  el.appendChild(li);<br />
}</code></pre>
<p>I got&nbsp;<em>1403 ms</em>&nbsp;in Internet Explorer 6 and&nbsp;<em>165 ms</em>&nbsp;in Firefox 1.5. Not so bad, but what about creating DOM element from HTML code?</p>
<pre class="prettyprint linenums"><code>for (var i = 1; i &lt; = 1000; i++) {<br />
  var li = document.createElement('&lt;li&gt;Element ' + i + ')<br />
  el.appendChild(li);<br />
}</code></pre>
<p>It works better in Internet Explorer (<em>1134 ms</em>), but does not work in Firefox at all. Weird! Of course, you can add&nbsp;<tt>try/catch</tt>&nbsp;block and create elements using first approach in&nbsp;<tt>catch</tt>&nbsp;block for Firefox. But I have a better solution.</p>
<p>Every DOM node has the attribute&nbsp;<tt>innerHTML</tt>&nbsp;which holds all child nodes as an HTML string.</p>
<pre class="prettyprint linenums"><code>el.innerHTML = '';<br />
for (var i = 1; i &lt; = 1000; i++) {<br />
  el.innerHTML += '&lt;li&gt;Element ' + i + '';<br />
}</code></pre>
<p>Wow,&nbsp;<em>39757 ms</em>&nbsp;in Internet Explorer and&nbsp;<em>41058 ms</em>&nbsp;in Firefox! Cool result, right? It's because browser tried to render list while we updating and it takes such a long time. Little optimization:</p>
<pre class="prettyprint linenums"><code>var html = '';<br />
for (var i = 1; i &lt; = 1000; i++) {<br />
  html += '&lt;li&gt;Element ' + i + '';<br />
}<br />
el.innerHTML = html;</code></pre>
<p>Firefox shows great performance,&nbsp;<em>50 ms</em>, but Internet Explorer still slow &ndash;&nbsp;<em>10994 ms</em>. I found solution which works very fast in both browsers: to create array of HTML chunks, and the join them using empty string:</p>
<pre class="prettyprint linenums"><code>var html = [];<br />
for (var i = 1; i &lt; = 1000; i++) {<br />
  html.push('&lt;li&gt;Element ');<br />
  html.push(i);<br />
  html.push('');<br />
}<br />
el.innerHTML = html.join('');</code></pre>
<p>It&rsquo;s fastest approach for Internet Explorer 6 &ndash;&nbsp;<em>407 ms</em>, and very fast in Firefox &ndash;&nbsp;<em>47 ms</em>. Why I&rsquo;m not saying fastest in case of Firefox? I added another test to make in cleaner:</p>
<pre class="prettyprint linenums"><code>var html = '';<br />
for (var i = 1; i &lt; = 1000; i++) {<br />
  html += '&lt;li style="padding-left: ' + (i % 50) + '" id="item-' + i + '"&gt;Element ' + i + ' Column ' + (i % 50) + '';<br />
}<br />
el.innerHTML = html;</code></pre>
<p>And second example:</p>
<pre class="prettyprint linenums"><code>var html = [];<br />
for (var i = 1; i &lt; = 1000; i++) {<br />
  html.push('&lt;li style="padding-left: ');<br />
  html.push(i % 50);<br />
  html.push('" id="item-');<br />
  html.push(i);<br />
  html.push('"&gt;Element ');<br />
  html.push(i);<br />
  html.push(' Column ');<br />
  html.push(i % 50);<br />
  html.push('');<br />
}<br />
el.innerHTML = html.join('');</code></pre>
<p><em>84 ms</em>&nbsp;for the first example and&nbsp;<em>110 ms</em>&nbsp;for the second.</p>
<p>Here is results in table and diagram formats.</p>
<table>
<thead>
<tr>
<th>No</th>
<th>Method</th>
<th>Internet Explorer 6</th>
<th>Firefox 1.5</th>
</tr>
</thead>
<tbody>
<tr>
<td>1</td>
<td><tt>document.createElement()</tt></td>
<td>1403</td>
<td>166</td>
</tr>
<tr>
<td>2</td>
<td><tt>document.createElement() Full</tt></td>
<td>1134</td>
<td>&mdash;</td>
</tr>
<tr>
<td>3</td>
<td><tt>element.innerHTML</tt></td>
<td>39757</td>
<td>41058</td>
</tr>
<tr>
<td>4</td>
<td><tt>element.innerHTML Optimized</tt></td>
<td>10994</td>
<td>50</td>
</tr>
<tr>
<td>5</td>
<td><tt>element.innerHTML Join</tt></td>
<td>400</td>
<td>47</td>
</tr>
<tr>
<td>6</td>
<td><tt>element.innerHTML Optimized Large</tt></td>
<td>28934</td>
<td>84</td>
</tr>
<tr>
<td>7</td>
<td><tt>element.innerHTML Join Large</tt></td>
<td>950</td>
<td>110</td>
</tr>
</tbody>
</table>
<div><img referrerpolicy="no-referrer"src="http://wildbit.com/blog-images/2006/11/image001.gif" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>结论：通过数组的方式会提高执行效率。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<h1>2、JavaScript DocumentFragment：更快捷的操作DOM的途径</h1>
<p>抄自：http://itindex.net/detail/49284-javascript-documentfragment-dom</p>
<h2>DocumentFragment例子</h2>
<p>我们要使用UL元素，然后往里面插入LI元素：</p>
<pre class="prettyprint linenums">&lt;ul id="list"&gt;&lt;/ul&gt;</pre>
<p>DOM插入和修改是一个很费力耗时的工作，所以，这样的交互越少越好。这就是DocumentFragment发挥功用的地方了。第一步我们先创建一个DocumentFragment：</p>
<pre class="prettyprint linenums">// Create the fragment<br />
var frag = document.createDocumentFragment();</pre>
<p>DocumentFragment实际上像一个伪DOM节点，在这个例子里你可以把它当成虚拟的UL元素。现在，我们开始往里面加入元素：</p>
<pre class="prettyprint linenums">// Create numerous list items, add to fragment<br />
for(var x = 0; x &lt; 10; x++) {<br />
	var li = document.createElement("li");<br />
	li.innerHTML = "List item " + x;<br />
	frag.appendChild(li);<br />
}</pre>
<p>往DocumentFragment里添加元素就跟你操作普通的DOM节点一样。一旦页面DOM加载完成，你可以访问了，你就可以把DocumentFragement挂到它的父节点上：</p>
<pre class="prettyprint linenums">// Mass-add the fragment nodes to the list<br />
listNode.appendChild(frag);</pre>
<p>使用DocumentFragement要比直接对DOM节点操作要快的多，而且程序员可以利用新DOM节点来操作DocumentFragement，这样比操作整个页面DOM要更容易。所以，当需要进行大量DOM操作时，尽量使用DocumentFragement，它会让你的应用变的更快！</p>
<p>结合以上文章可以发现：结合使用</p>
<h1>DocumentFragment</h1>
<h1>数组</h1>
<p>可大大提高执行效率。</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390dlg38.html">AngularJS 表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93kwrnq.html">jquery里的on方法使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2e1kwq.html">【转载】Android内存泄露</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnz3y3q.html">必须使用&OpenCurlyDoubleQuote;角色管理工具&rdquo;安装或配置Microsoft &period;NET Framework 3&period;5 SP1</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vel2j8.html">Ubuntu系统下载工具的推荐</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w0lp3q.html">hibernate  get VS load</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1v6x69.html">java：异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljl7319.html">Spyder提示ValueError&colon; API &amp;&num;39&semi;QString&amp;&num;39&semi; has already been set to version 1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvkme9.html">FineReport单元格扩展与父子格设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me645pq.html">归档（NSKeyedArchiver）的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z1gj59.html">&lbrack;NOI2016&rsqb;循环之美</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pwovj8.html">Dynamics CRM2013 Server2012R2下IFD部署遇到There is already a listener on IP endpoint的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y045n8.html">TypeScript之interface初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ozjnx8.html">JavaScript进度条（datalist&sol;repeater等多个进度条）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wd4yzq.html">网址，域名，IP，主机名的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4ox6k9.html">Java 9 中的 9 个新特性你知道吗</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rn7549.html">C&num; ADO&period;NET与面向对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o5m5j8.html">SAP固定资产业务场景及方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rgx248.html">【代码笔记】iOS-长条蓝色button</a>
		</li>
						<li><a href="https://www.batexi.com/a/95330me8.html">Windows下MFC程序利用LockCop解决死锁</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2jkdxx8.html">Android RecyclerView完全解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ypo108.html">mybatis 入门进阶之 pojo</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgnd5r8.html">C&num;&lowbar;单例模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jkjy38.html">H5与CS3权威下&period;19 选择器（2）结构性伪类选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgn5dm8.html">HTTP协议----ETag</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zeokx9.html">SwiftyUserDefaults-封装系统本地化的框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdppgz9.html">JUnit4单元测试基础篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk22pe8.html">Mac OS 上 CRT 的终端设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjn2vx8.html">一步步优化JVM五：优化延迟或者响应时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj153k9.html">Android中AlertDialog对话框禁止按&lbrack;返回键&rsqb;或&lbrack;搜索键&rsqb;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
